#ifndef _ACULABCLASS_
#define _ACULABCLASS_

#define WIN32_LEAN_AND_MEAN
#define NUMCALLSPERPORT 4
#define LOGTOFILE		1
#define TINGLOGTOFILE	1

#define USE_SANGOMA			1
#define TEST_SANGOMA_STUBS	0

#include "sangoma_interface.h"

#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <malloc.h>
#include <sys/timeb.h>
#include <time.h>
#include <stdarg.h>

#include "acu_type.h"
#include "res_lib.h"
#include "cl_lib.h"
#include "sw_lib.h"
#include "smdrvr.h"
#include "smbesp.h"		
#include "smhlib.h"		
#include "smwavlib.h"	
#include "smrtp.h"
#include "prosody_x.h"

extern "C"{
#include "SDPhandling.h"
}

#include <windows.h>
#include <winbase.h>
#include <winsock2.h>

#if TEST_SANGOMA_STUBS
#include "sangoma_interface.h"
#endif

typedef enum{
	ACU_CLASS=1,
	ACU_INCOMING,
	ACU_OUTGOING,
	ACU_DTMF
}ACU_CLASS_TYPE;

typedef struct _call_data
{
	char								orig[30];
	char								dest[30];
	ACU_INT								ts;
	ACU_INT								port;
	ACU_INT								stream;
	ACU_CALL_HANDLE						handle;
	BOOL								connected;	
	BOOL								opened;
	BOOL								disconnected;
	BOOL								IsSIPCall;
	HANDLE 								IdleEventHandle;
	HANDLE 								ConnectedEventHandle;
	HANDLE								DoneEventHandle;
	HANDLE								ReserveRTPEventHandle;
	HANDLE								ConfigureRTPEventHandle;
	HANDLE								ExitEventHandle;
	tSMChannelId						TiNG_ChannelId;
	ACU_INT								TiNG_stream;
	ACU_INT								TiNG_timeslot;
	HANDLE								vmprx_event;
	HANDLE								vmptx_event;
	ACU_INT								module;
	ACU_MEDIA_OFFER_ANSWER*				offer;
	SM_VMPRX_CREATE_PARMS				vmp_rx;
	SM_VMPTX_CREATE_PARMS				vmp_tx;
	SIP_DETAIL_PARMS					sip_details_parms;
	int									init_once;
	int									rtp_port;
	int									rtcp_port;
	class sangoma_interface*			S;
}CALL_DATA;

typedef struct _port_data
{
	ACU_PORT_ID			port_id;
	ACU_INT				port;
	ACU_INT				calls_in_progress;
	ACU_EVENT_QUEUE		in_queue_id;
	ACU_EVENT_QUEUE		out_queue_id;
	HANDLE				done_event;
	CRITICAL_SECTION	IN_CS;
	CRITICAL_SECTION	OUT_CS;
	CALL_DATA*			pBChanDataIN;
	CALL_DATA*			pBChanDataOUT;
}PORT_DATA;

typedef struct _module_data
{
	ACU_INT				module;	
	tSMModuleId			module_id;	
}MODULE_DATA;

class AculabClass
{

protected:
	ACU_CLASS_TYPE	class_type;

public:

	ACU_CLASS_TYPE get_class_type()
	{
		return class_type;
	}


	AculabClass(void);
	~AculabClass(void);
	static void Init(void);
	static void Cleanup(void);
	static void ErrorPrint(char *InFunction, char *Call, int rc);
	static void LogPrint(char* format, ...);
	static int TingLogPrint(const char* format, va_list arglist);

	static int			initialized;
	static int			iExit;
	static ACU_UINT		unCardId;
	static ACU_PORT_ID	cSipPortId;
	static int			modules;
	static ACU_UINT		unPorts;
	static ACU_CHAR		card_ip_address[ACU_MAX_IP_ADDRESS];

	static PORT_DATA*	pPortData;
	static MODULE_DATA*	pModuleData;
	
	//char				ch;

private:

		
};



#endif

