#ifndef _DTMFCLASS_
#define _DTMFCLASS_

#include "AculabClass.h"

typedef struct _dtmf_data
{
	int									ThreadNum;
	int									DTMFDetect;
	char								DTMFGenerateDigits[20];
	char								DTMFDetectDigits[20];
	long								DTMFDetectTimeout;
	BOOL								ThreadWorking;
	HANDLE 								StartEventHandle;
	HANDLE 								ExitEventHandle;
	class sangoma_interface*			S;
}DTMF_DATA;


class DTMFClass : public AculabClass
{
public:
	 DTMFClass(void);
	~DTMFClass(void);
	void StartThread(int);
	void DoDTMFDetection(class sangoma_interface*, long);
	void DoDTMFGeneration(char*, class sangoma_interface*);
	void Lock() 
	{ 
		EnterCriticalSection(&DTMF_CS);
	}
	void UnLock() 
	{
		LeaveCriticalSection(&DTMF_CS);
	}
	void SetDTMFDetectedCallback(void (*fp)(char*,class sangoma_interface*));
	void DoDTMFDetectedCallback(DTMF_DATA*);
		
	static int				init_once;
	static DTMF_DATA*		pDTMFData;
		
private:

	CRITICAL_SECTION		DTMF_CS;
	void (*fpDTMFDetectedCallback)(char*,class sangoma_interface*);
		
};


#endif

