#ifndef _INCOMINGCLASS_
#define _INCOMINGCLASS_

#include "AculabClass.h"

class IncomingClass : public AculabClass
{
public:
	IncomingClass(void);
	~IncomingClass(void);

	int	 Reserve_RTP(CALL_DATA*);
	int  Get_RTP_TX_Status(CALL_DATA*);
	int  Get_RTP_RX_Status(CALL_DATA*);
	void Configure_RTP(CALL_DATA*, SIP_DETAIL_PARMS*);
	void Connect_RTP_to_TiNG(CALL_DATA*);
	void Disconnect_RTP_from_TiNG(CALL_DATA*);
	void Stop_RTP(CALL_DATA*);

	enum kSMCodecType convert_payload_number_to_ting(ACU_INT);

	ACU_CALL_HANDLE OpenIncoming(int ts);
	ACU_ERR handle_ev_incoming_call_det(const ACU_CALL_HANDLE, int, ACU_MEDIA_OFFER_ANSWER**);
	ACU_ERR handle_ev_media(const ACU_CALL_HANDLE, const ACU_INT, SIP_DETAIL_PARMS*);
	ACU_ERR handle_ev_call_connected(const ACU_CALL_HANDLE);
	ACU_ERR handle_ev_idle(const ACU_CALL_HANDLE);
	ACU_ERR handle_sip_accept(CALL_DATA*);

	void SetIncomingDetectedCallback(void (*fp)(ACU_CALL_HANDLE,int,char*));
	void SetIncomingConnectedCallback(void (*fp)(ACU_CALL_HANDLE,int));
	void SetIncomingIdleCallback(void (*fp)(ACU_CALL_HANDLE,int));
	void Send200OK(int);
	void DoIncomingDetectedCallback(CALL_DATA*);
	void DoIncomingConnectedCallback(CALL_DATA*);
	void DoIncomingIdleCallback(CALL_DATA*);
	void DisconnectCall(int);
	void SetSangomaObject(class sangoma_interface*, int);
	void * GetSangomaObject(int ts);

private:

	void (*fpIncomingDetectedCallback)(ACU_CALL_HANDLE,int,char*);
	void (*fpIncomingConnectedCallback)(ACU_CALL_HANDLE,int);
	void (*fpIncomingIdleCallback)(ACU_CALL_HANDLE,int);
	
};


#endif

