#ifndef _OUTGOINGCLASS_
#define _OUTGOINGCLASS_

#include "AculabClass.h"

class OutgoingClass : public AculabClass
{
public:
	OutgoingClass(void);
	~OutgoingClass(void);

	int	 Reserve_RTP(CALL_DATA*);
	int  Get_RTP_TX_Status(CALL_DATA*);
	int  Get_RTP_RX_Status(CALL_DATA*);
	void Configure_RTP(CALL_DATA*, SIP_DETAIL_PARMS*);
	void Connect_RTP_to_TiNG(CALL_DATA*);
	void Disconnect_RTP_from_TiNG(CALL_DATA*);
	void Stop_RTP(CALL_DATA*);

	enum kSMCodecType convert_payload_number_to_ting( ACU_INT payload_number );

	ACU_ERR OpenOutgoing(int, char*, char*, class sangoma_interface *);

	ACU_ERR sip_open_outgoing(CALL_DATA* ChanData, PORT_DATA* PortData);
	ACU_ERR handle_ev_media(const ACU_CALL_HANDLE handle, const ACU_INT is_reinvite, SIP_DETAIL_PARMS* sip_details_parms);
	ACU_ERR handle_ev_call_connected(const ACU_CALL_HANDLE handle, int ts);
	ACU_ERR handle_ev_idle(const ACU_CALL_HANDLE handle);

	void SetOutgoingConnectedCallback(void (*fp)(ACU_CALL_HANDLE,int));
	void SetOutgoingIdleCallback(void (*fp)(ACU_CALL_HANDLE,int));
	void DoOutgoingConnectedCallback(CALL_DATA*);
	void DoOutgoingIdleCallback(CALL_DATA*);
	void DisconnectCall(int ts);

	void SetSangomaObject(class sangoma_interface* so, int ts);
	void *GetSangomaObject(int ts);

private:

	void (*fpOutgoingConnectedCallback)(ACU_CALL_HANDLE,int);
	void (*fpOutgoingIdleCallback)(ACU_CALL_HANDLE,int);
};

#endif

