#ifndef _MEDIA_HANDLING_H_
#define _MEDIA_HANDLING_H_

#include <stdio.h>
#include <stdlib.h>

#include <acu_type.h>
#include <res_lib.h>
#include <cl_lib.h>

#define BLACKHOLE_CONNECTION_ADDRESS   "0.0.0.0"
//#define LOCAL_CONNECTION_ADDRESS		"192.168.204.106"
#define LOCAL_CONNECTION_ADDRESS		"192.168.1.122"
#define LOCAL_RTP_PORT					16388

ACU_MEDIA_OFFER_ANSWER *clone_media_offer(const ACU_MEDIA_OFFER_ANSWER *offer);
ACU_MEDIA_DESCRIPTION *clone_media_descriptions(ACU_MEDIA_DESCRIPTION *media_descriptions);
ACU_PAYLOAD *clone_payloads(const ACU_PAYLOAD *payloads, const ACU_MEDIA_TYPES media_type);
ACU_PAYLOAD *clone_audio_video_payloads(const ACU_PAYLOAD *payloads);
ACU_PAYLOAD *clone_image_payloads(const ACU_PAYLOAD *payloads);
ACU_PAYLOAD *clone_control_payloads(const ACU_PAYLOAD *payloads);
ACU_MISCELLANEOUS_MEDIA_ATTRIBUTE *clone_misc_attributes(ACU_MISCELLANEOUS_MEDIA_ATTRIBUTE *misc_attributes);
void free_media_offer(ACU_MEDIA_OFFER_ANSWER **stored_offer);
void free_media_descriptions(ACU_MEDIA_DESCRIPTION **media_descriptions);
void free_payloads(ACU_PAYLOAD **payloads, const ACU_MEDIA_TYPES media_type);
void free_audio_video_payloads(ACU_PAYLOAD **payloads);
void free_image_payloads(ACU_PAYLOAD **payloads);
void free_misc_attributes(ACU_MISCELLANEOUS_MEDIA_ATTRIBUTE **misc_attribute);
ACU_MEDIA_OFFER_ANSWER *populate_media_answer(ACU_MEDIA_OFFER_ANSWER *stored_offer);
ACU_MEDIA_OFFER_ANSWER *populate_media_offer(ACU_UINT payload_number, ACU_INT black_hole, ACU_INT no_media);
ACU_INT codec_is_supported(const ACU_INT payload_number);
ACU_CHAR *convert_payload_number_to_name(const ACU_UINT payload_number);

#endif // #ifndef _MEDIA_HANDLING_H_
